<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:schema="https://schema.org/"
    xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:tei="http://www.tei-c/ns/1.0"
    xmlns:frbroo="D" 
    xmlns:owl="http://www.w3.org/TR/2004/REC-owl-guide-20040210/"
    xmlns:fa="http://www.w3.org/2005/xpath-functions"
    xmlns:crm="http://www.cidoc-crm.org/cidoc-crm/"
    xmlns:cwrc="http://sparql.cwrc.ca/ontologies/cwrc.html"
    xmlns:map="http://www.w3.org/2005/xpath-functions/map"
    exclude-result-prefixes="cwrc xsl schema rdf tei fa owl xs"
    xpath-default-namespace="http://www.tei-c.org/ns/1.0" version="2.0"
       xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">
    <xsl:output method="xml" encoding="UTF-16" indent="yes"/> <!--declare frbroo-->
    
    <xsl:template match="/">
        <rdf:RDF xml:lang="en"   
            xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
            xmlns:crm="http://www.cidoc-crm.org/cidoc-crm/"
            xmlns:skos="http://www.w3.org/2004/02/skos/core#"
            xmlns:temp_lincs_temp="http://temp.lincsproject.ca/"
            xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#">
            <xsl:apply-templates select="descendant::listPerson"/>
        </rdf:RDF>
    </xsl:template>
    
    <!-- TODO Add cwrc URIs + process <note> with the word doc inside LINCS Drive -->
    
    <xsl:template match="listPerson">
        <xsl:apply-templates select="person"/>
    </xsl:template>
    
    <xsl:template match="person">
        <crm:E39_Actor rdf:about="uri:Name_of_Person">
            <rdfs:label>
                <xsl:value-of select="normalize-space(persName[@type='preferred'])"/>
            </rdfs:label>  
                      
            <xsl:apply-templates select="persName[@type='preferred']"/>
            <xsl:apply-templates select="persName[@type='variant']"/>
            <xsl:apply-templates select="birth"/>
            <xsl:apply-templates select="death"/>
            <xsl:apply-templates select="nationality"/>
            <xsl:apply-templates select="occupation"/>
            <xsl:apply-templates select="note[@type='general']"/>
            <!--About <floruit>: CC & AD: There isn’t a application profile for this so we should leave it for now to be safe-->
            <!--About <trait>: CC & AD: There isn’t a application profile for this so we should leave it for now to be safe-->
            <!--About <respons>: CC & AD: There isn’t a application profile for this so we should leave it for now to be safe-->
            <xsl:apply-templates select="sex"/>
            
        </crm:E39_Actor>       
    </xsl:template>

    
    <xsl:template match="persName[@type='preferred']">
            <crm:P1_is_identified_by>
                <crm:E33_E41_Linguistic_Appellation rdf:about="uri:Name_of_Person">
                    <rdfs:label>Name of <xsl:value-of select="normalize-space(.)"/>
                    </rdfs:label>
                    <crm:P190_has_symbolic_content xml:lang="en">
                        <xsl:value-of select="normalize-space(.)"/>
                    </crm:P190_has_symbolic_content>
                    <crm:P2_has_type>
                        <crm:E55_Type rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#PersonalName"/>
                    </crm:P2_has_type>
                    
                   <xsl:apply-templates select="child::name[@type='forename']"/> 
                    <xsl:apply-templates select="child::name[@type='middlename']"/>
                    <xsl:apply-templates select="child::name[@type='surname']"/>
                    <xsl:apply-templates select="child::genName"/>
                    <!--<xsl:apply-templates select="child::roleName"/>
                    CC & AD: There isn’t a application profile for this so we should leave it for now to be safe-->                                      
                    
                </crm:E33_E41_Linguistic_Appellation>
            </crm:P1_is_identified_by>
    </xsl:template>
    
    <xsl:template match="persName[@type='variant']">
        <crm:P1_is_identified_by>
            <crm:E33_E41_Linguistic_Appellation rdf:about="uri:Name_of_Person">
                <rdfs:label>Name of <xsl:value-of select="normalize-space(.)"/>
                </rdfs:label>
                <crm:P190_has_symbolic_content xml:lang="en">
                    <xsl:value-of select="normalize-space(.)"/>
                </crm:P190_has_symbolic_content>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="http://sparql.cwrc.ca/ontologies/cwrc#PersonalName"/>
                </crm:P2_has_type>
                
                <xsl:apply-templates select="child::name[@type='forename']"/> 
                <xsl:apply-templates select="child::name[@type='middlename']"/>
                <xsl:apply-templates select="child::name[@type='surname']"/>
                <xsl:apply-templates select="child::genName"/>
                                                                
            </crm:E33_E41_Linguistic_Appellation>
        </crm:P1_is_identified_by>

        <crm:P67i_is_referred_to_by>
           <xsl:apply-templates select="child::note"/>
        </crm:P67i_is_referred_to_by>
    </xsl:template>
 
    <xsl:template match="name[@type='forename']">
        <crm:P106_is_composed_of xml:lang="en">
        <crm:E33_E41_Linguistic_Appellation rdf:about="uri:First_Name_of_Person">
            <rdfs:label>Forename of <xsl:value-of select="normalize-space(ancestor::persName[@type='preferred'])"/>
            </rdfs:label>
            <crm:P190_has_symbolic_content xml:lang="en">
                <xsl:value-of select="normalize-space(.)"/>
            </crm:P190_has_symbolic_content>
            <crm:P2_has_type>
                <crm:E55_Type rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#Forename"/>
            </crm:P2_has_type>
        </crm:E33_E41_Linguistic_Appellation>
        </crm:P106_is_composed_of>
    </xsl:template>
        
       
    <xsl:template match="name[@type='middlename']">        
        <crm:P106_is_composed_of xml:lang="en">
            <crm:E33_E41_Linguistic_Appellation rdf:about="uri:Middlename_of_Person">
                <rdfs:label>Middlename of <xsl:value-of select="normalize-space(ancestor::persName[@type='preferred'])"/>
                </rdfs:label>
                <crm:P190_has_symbolic_content xml:lang="en">
                    <xsl:value-of select="normalize-space(.)"/>
                </crm:P190_has_symbolic_content>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="uri:cwrc.html#Middlename"/>
                </crm:P2_has_type>
            </crm:E33_E41_Linguistic_Appellation>
        </crm:P106_is_composed_of>    
    </xsl:template>
    
    <xsl:template match="name[@type='surname']">
        <crm:P106_is_composed_of xml:lang="en">
            <crm:E33_E41_Linguistic_Appellation rdf:about="uri:Surname_of_Person">
                <rdfs:label>Surname of <xsl:value-of select="normalize-space(ancestor::persName[@type='preferred'])"/>
                </rdfs:label>
                <crm:P190_has_symbolic_content xml:lang="en">
                    <xsl:value-of select="normalize-space(.)"/>
                </crm:P190_has_symbolic_content>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="http://sparql.cwrc.ca/ontologies/cwrc#Surname"/>
                </crm:P2_has_type>
            </crm:E33_E41_Linguistic_Appellation>
        </crm:P106_is_composed_of>    
    </xsl:template>
    
    <xsl:template match="genName">
        <crm:P106_is_composed_of xml:lang="en">
            <crm:E33_E41_Linguistic_Appellation rdf:about="uri:genName_of_Person">
                <rdfs:label>Generational name of <xsl:value-of select="normalize-space(ancestor::persName[@type='preferred'])"/>
                </rdfs:label>
                <crm:P190_has_symbolic_content xml:lang="en">
                    <xsl:value-of select="normalize-space(.)"/>
                </crm:P190_has_symbolic_content>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#GenerationalName"/>
                </crm:P2_has_type>
            </crm:E33_E41_Linguistic_Appellation>
        </crm:P106_is_composed_of>    
    </xsl:template>
    
    <xsl:template match="roleName">
        <crm:P106_is_composed_of xml:lang="en">
            <crm:E33_E41_Linguistic_Appellation rdf:about="uri:roleName_of_Person">
                <rdfs:label>Role name of <xsl:value-of select="normalize-space(ancestor::persName[@type='preferred'])"/>
                </rdfs:label>
                <crm:P190_has_symbolic_content xml:lang="en">
                    <xsl:value-of select="normalize-space(.)"/>
                </crm:P190_has_symbolic_content>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="http://sparql.cwrc.ca/ontologies/cwrc#RoleName"/>
                </crm:P2_has_type>
            </crm:E33_E41_Linguistic_Appellation>
        </crm:P106_is_composed_of>    
    </xsl:template>
    
    <xsl:template match="note">
        <crm:E33_Linguistic_Object rdf:about="uri:Name_of_Person"> 
            <rdfs:label>Name of label : Note about the person's variant name</rdfs:label>
            <crm:P190_has_symbolic_content xml:lang="en">
                <xsl:value-of select="normalize-space(.)"/>
            </crm:P190_has_symbolic_content>
            <crm:P2_has_type>
                <crm:E55_Type rdf:about="http://sparql.cwrc.ca/ontologies/cwrc#Note"/>
            </crm:P2_has_type>            
        </crm:E33_Linguistic_Object>        
    </xsl:template>
        
    <xsl:template match="birth">
        <crm:P98i_was_born>
            <crm:E67_Birth rdf:about="uri:Name_of_Person">
                <rdfs:label>Birth of <xsl:value-of select="normalize-space(preceding-sibling::persName[@type='preferred'])"/></rdfs:label>
               
               <xsl:apply-templates select="./date"/>
               <!--<xsl:apply-templates select="./placeName"/>
               CC: we need to be able to associate the place with the fact that the person was born there (just as we do with a timespan “this person had a birth time and this is the birthtime and its properties”). Leave it in comments, not converting, waiting for an official “How to connect placenames to birth and death events” from LINCS
               CC: They’ll have URIs for all the places coming from LEAF Writer-->
               
            </crm:E67_Birth>
        </crm:P98i_was_born>
    </xsl:template>
    
    <xsl:template match="death">
        <crm:P100i_died_in>
            <crm:E69_Death rdf:about="uri:Name_of_Person">
                <rdfs:label>Death of <xsl:value-of select="normalize-space(preceding-sibling::persName[@type='preferred'])"/></rdfs:label>
                
                <xsl:apply-templates select="./date"/>
                <!--<xsl:apply-templates select="./placeName"/>
                 CC: we need to be able to associate the place with the fact that the person was born there (just as we do with a timespan “this person had a birth time and this is the birthtime and its properties”). Leave it in comments, not converting, waiting for an official “How to connect placenames to birth and death events” from LINCS
                CC: They’ll have URIs for all the places coming from LEAF Writer-->
                <!--Information pointing to the location of Birth will go in here when we have the CIDOC pattern for Birth locations-->
                
            </crm:E69_Death>
        </crm:P100i_died_in>
    </xsl:template>
    
    <xsl:template match="birth/date">
        <crm:P4_has_time-span>
            <crm:E52_Time-Span rdf:about="uri:Time_Span">
                <rdfs:label>Datetime of birth of <xsl:value-of select="normalize-space(preceding::persName[@type='preferred'])"/></rdfs:label>
                <crm:P82_at_some_time_within>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82_at_some_time_within>
                <crm:P82b_end_of_the_end>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82b_end_of_the_end>
                <crm:P82a_begin_of_the_begin>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82a_begin_of_the_begin> 
            </crm:E52_Time-Span>
        </crm:P4_has_time-span>
    </xsl:template>
    
    <!--AD: Not transforming yet, because we don't know how to connect the E53 Place to the birth and death event, missing a P_property?
        <xsl:template match="birth/placeName">        
        <crm:E53_Place rdf:about="uri:Name_of_Place?">
            <rdfs:label>
                <xsl:value-of select="normalize-space(.)"/>
            </rdfs:label>            
            <crm:P1_is_identified_by>
                <crm:E33_E41_Linguistic_Appellation rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#birthPlace">
                    <crm:P190_has_symbolic_content>
                        <xsl:value-of select="normalize-space(.)"/>
                    </crm:P190_has_symbolic_content>
                </crm:E33_E41_Linguistic_Appellation>
            </crm:P1_is_identified_by>
        </crm:E53_Place>        
    </xsl:template>-->
    
    <xsl:template match="death/date">
        <crm:P4_has_time-span>
            <crm:E52_Time-Span rdf:about="uri:Time_Span">
                <rdfs:label>Datetime of death of <xsl:value-of select="normalize-space(preceding::persName[@type='preferred'])"/></rdfs:label>
                <crm:P82_at_some_time_within>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82_at_some_time_within>
                <crm:P82b_end_of_the_end>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82b_end_of_the_end>
                <crm:P82a_begin_of_the_begin>"<xsl:value-of select="@when"/>"^^xsd:dateTime</crm:P82a_begin_of_the_begin> 
            </crm:E52_Time-Span>
        </crm:P4_has_time-span>
    </xsl:template>
    
    <!-- AD: Not transforming yet, because we don't know how to connect the E53 Place to the birth and death event, missing a P_property?
        <xsl:template match="death/placeName">        
        <crm:E53_Place rdf:about="uri:Name_of_Place?">
            <rdfs:label><xsl:value-of select="normalize-space(.)"/></rdfs:label>            
            <crm:P1_is_identified_by>
                <crm:E33_E41_Linguistic_Appellation rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#deathPlace">
                    <crm:P190_has_symbolic_content>
                        <xsl:value-of select="normalize-space(.)"/>
                    </crm:P190_has_symbolic_content>
                </crm:E33_E41_Linguistic_Appellation>
            </crm:P1_is_identified_by>
        </crm:E53_Place>        
    </xsl:template>-->
      
    <!-- Mapping the NATIONALITY
            1 - Define a variable to store the beginning of our URI. -->
    <xsl:variable name="nationalityPrefix" 
        select="'http://sparql.cwrc.ca/ontologies/cwrc#'"/>
    <!-- 2 - Define a variable to store the map then create the map.-->
    <xsl:variable name="nationality" as="map(xs:string, xs:string)">
        <xsl:map>
            <xsl:map-entry key="'africanNationalIdentity'" select="'africanNationalIdentity'"/>
            <xsl:map-entry key="'anglo-IndianNationalIdentity'" select="'anglo-IndianNationalIdentity'"/>
            <xsl:map-entry key="'anglo-IrishNationalIdentity'" select="'anglo-IrishNationalIdentity'"/>
            <xsl:map-entry key="'britishNationalIdentity'" select="'britishNationalIdentity'"/>
            <xsl:map-entry key="'europeanNationalIdentity'" select="'europeanNationalIdentity'"/>
            <xsl:map-entry key="'florentineNationalIdentity'" select="'florentineNationalIdentity'"/>
            <xsl:map-entry key="'hanoverianNationalIdentity'" select="'hanoverianNationalIdentity'"/>
            <xsl:map-entry key="'jewishNationalIdentity'" select="'jewishNationalIdentity'"/>
            <xsl:map-entry key="'mohawkNationalIdentity'" select="'mohawkNationalIdentity'"/>
            <xsl:map-entry key="'saxonNationalIdentity'" select="'saxonNationalIdentity'"/>
            <xsl:map-entry key="'sephardicJewishNationalIdentity'" select="'sephardicJewishNationalIdentity'"/>
            <xsl:map-entry key="'statelessNationalIdentity'" select="'statelessNationalIdentity'"/>            
        </xsl:map>
    </xsl:variable>
    
   <xsl:template match="nationality">
        <crm:P74_has_current_or_former_residence>
            <crm:E53_Place rdf:about="uri:Name_of_Place">
                <crm:P1_is_identified_by>
                    <crm:E33_E41_Linguistic_Appellation rdf:about="uri:Name_of_Place">
                        <crm:P190_has_symbolic_content xml:lang="en">
                            <xsl:value-of select="normalize-space(.)"/> : nationality of the person e.g. the place where they live
                        </crm:P190_has_symbolic_content>
                        <crm:P2_has_type>
                            <xsl:choose>
                                <xsl:when test="map:contains($nationality, current())">
                                    <crm:E55_Type rdf:about="{concat($nationalityPrefix, $nationality(current()), '')}"/>
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:comment>ERROR : No URI was found for nationality : "<xsl:value-of select="current()"/>". Please check the content of the @value or rely on our documentation to input correct format.</xsl:comment>
                                </xsl:otherwise>
                            </xsl:choose>         
                        </crm:P2_has_type>                        
                    </crm:E33_E41_Linguistic_Appellation>
                </crm:P1_is_identified_by>
            </crm:E53_Place>
        </crm:P74_has_current_or_former_residence>
    </xsl:template>
    
       <xsl:template match="occupation">
        <crm:P14i_performed>
            <frbroo:F51_Pursuit rdf:about="uri:Pursuit_of_Name_of_Person"> 
                <!-- URI = Name of Person ? or of concept for "Pursuit"?-->
                <crm:P2_has_type>
                    <xsl:element name="{concat('crm:', 'E55_Type')}">
                        <xsl:attribute name="rdf:about" select="@source"></xsl:attribute>
                    </xsl:element>  
                </crm:P2_has_type>
            </frbroo:F51_Pursuit>
        </crm:P14i_performed>
    </xsl:template>
    
    <xsl:template match="sex">
        <crm:P140i_was_attributed_by>
            <crm:E13_Attribute_Assignment>
                <rdfs:label>Gender of <xsl:value-of select="normalize-space(preceding::persName[@type='preferred'])"/>
                </rdfs:label>
                <crm:P2_has_type>
                    <crm:E55_Type rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#GenderContext"/>            
                </crm:P2_has_type>
                <crm:P141_assigned>
                    <crm:E7_Activity>
                        <crm:P2_has_type>
                            <crm:E55_Type rdf:about="https://sparql.cwrc.ca/ontologies/cwrc.html#GenderEvent"/>            
                        </crm:P2_has_type>
                        <xsl:element name="{concat('crm:', 'P16_used_specific_object')}">
                            <xsl:attribute name="rdf:resource" select="@source"></xsl:attribute>
                        </xsl:element>  
                    </crm:E7_Activity>                    
                </crm:P141_assigned>
            </crm:E13_Attribute_Assignment>
        </crm:P140i_was_attributed_by>   
    </xsl:template>
</xsl:stylesheet>
